#include "FireBrick.h"

FireBrick::FireBrick (Field *field, hgeVector center, float x, float y, int i, int j, float angle,
            const char* textureName):Brick (field, center, x, y, i, j, angle, textureName) {
            dieSnd = hge->Effect_Load(BRICK_DIE_SND_NAME.c_str());
}

void FireBrick::onHit() {
    field->destroyBrick(i, j);
}

void FireBrick::die() {
     hge->Effect_PlayEx (dieSnd);
    for (int i1=-1; i1<=1; i1++) {
        for (int j1=-1; j1<=1; j1++) {
            field->destroyBrick(i+i1, j+j1, DET_TIME);
        }
    }
}
