#include <windows.h>
#include <iostream>
#include <fstream>
#include <hge.h>
#include <hgesprite.h>

#include <hgefont.h>
#include <hgeparticle.h>

#include "Field.h"


using namespace std;

HGE *hge = 0;

Field *field;

bool frame();

bool render ();

using namespace std;

int WINAPI WinMain (HINSTANCE, HINSTANCE, LPSTR, int) {

    hge = hgeCreate(HGE_VERSION);

    hge->System_SetState(HGE_FRAMEFUNC, frame);
    hge->System_SetState(HGE_RENDERFUNC, render);

    hge->System_SetState(HGE_WINDOWED, true);
    hge->System_SetState(HGE_SCREENWIDTH, 800);
    hge->System_SetState(HGE_SCREENHEIGHT, 600);
    hge->System_SetState(HGE_SCREENBPP, 32);

    hge->System_SetState(HGE_LOGFILE, "log.txt");
    hge->System_SetState(HGE_FPS, 100);


    hge->System_SetState(HGE_TITLE, "Alcaloid");

    if (hge->System_Initiate()) {

        field = new Field (hge);

        hge->System_Start();
    } else {
        MessageBox(NULL, hge->System_GetErrorMessage(), "Achtung", MB_OK|MB_ICONERROR|MB_APPLMODAL);
    }

    delete field;

    hge->System_Shutdown();
    hge->Release();

    return 0;
}


bool frame() {
    float dt=hge->Timer_GetDelta();

    if (hge->Input_GetKeyState(HGEK_ESCAPE))
        return true;
//
//    if (hge->Input_GetKeyState(HGEK_LEFT)) sbm->turnLeft();
//    if (hge->Input_GetKeyState(HGEK_RIGHT)) sbm->turnRight();
//    if (hge->Input_GetKeyState(HGEK_UP)) sbm->goForward();
//    if (hge->Input_GetKeyState(HGEK_DOWN)) sbm->goBackward();
//
//    if (hge->Input_GetKeyState(HGEK_SPACE)) sbm->upDown();
//    if (hge->Input_GetKeyState(HGEK_CTRL)) sbm->throwFlame();
//
    field->refresh(dt);
    return false;
}

bool render () {
    hge->Gfx_BeginScene();
    hge->Gfx_Clear(0);

    field->render();

    hge->Gfx_EndScene();

    return false;
}
