unit GMVars;

interface
  uses Windows;

const
Title='IDeyaX_OpenGL_Engine';
MouseLB=256;
MouseRB=257;
MouseMB=258;

Pi_180=Pi/180;
Pi_M180=Pi*180;
Pi_2=Pi/2;

TexW=1/256;

ActionCreate=0;
ActionSelect=1;
ActionNone=255;
WHEEL_DELTA=120;
type
TanimKadr=record
   GFXfileId:integer;
   Binfilename:string;
   Index:integer;
   x1,y1,x2,y2:real;
   w,h:real;
   Speed:integer;
end;


 type
  TVSyncMode = (vsmSync, vsmNoSync);

 type
 TState = (sGMenu, sOptions, sRecords, sAuthor, sExit, sGame,sDeath,sVictory);   //  

var
  SCRW:integer=800;
  SCRH:integer=600;
  SCR2W:integer=400;
  SCR2H:integer=300;
  SCRHZ:integer=60; // 
  SCRBit:integer=32; // 
  FullScreen:boolean=true;
  Sync:boolean=false;
  SCRXOffset:integer=0; // 
  SCRYOffset:integer=0;
  CenterScreen:boolean=false;

  AnimationBox:array of TanimKadr;

  EnterName:string='User';
  curpos:integer=4;
   
  GWHandle: hWnd;
  GWDC: HDC;
  GWHRC: HGLRC;
  GWInstance: HINST;


   CurrentTime : Longint;
   FPSLastTickCount : Longint;
   FPSFrames        : Longint;
   FPS              : Single;

   GUItexture:cardinal;

 Keys: array [0..258] of Boolean;
 MousePos:tpoint;

  m_mouseWheelDelta:integer= 0;
  m_mouseWheel:integer= 0;
  
  MySysfont:Dword;
  MySysfont2:Dword;

 Pathstr:string='';
 GameStatus:TState=sGMenu;
 SelectPunkt:integer=0;
 EngineStart:boolean=false;
 GamePaused:Boolean=false;

  wTime, wTime_Delta, wTime_Old,
  ups_delta, ups_time_old, ups_time : DWORD;

  fps_time  : Integer=0;
  fps_cur   : Integer=0;
  g_FPS     : Integer=0;
  Timer_Freq   : LARGE_INTEGER;
  
 Titul_menu : array[0..4] of string =
  (' ',
   '',
   '',
   '',
   '');

 Author_menu: array[0..20] of string=
  ('             :',
   '        aka Gambit_oz',
   '                   <IdeyaX studio>',
   '     e-Mail : greenrat@mail333.com',
   '',
   '             :',
   '            Gambit_oz',
   '',
   '           :',
   '             Gambit_oz',
   '',
   '        :',
   '         IDE          - Delphi 6',
   '               - Adobe Photoshop 7.0',
   '                      - 3dsmax 3.0',
   '       Sound          - www.yandex.ru',
   '',
   '',
   '',
   '      13.09.2007 - 23.09.2007',
   '        code.darthman.com');


implementation

end.
