unit HighScores;

interface
    uses SysUtils;
type THScore = record
Name : string[20];
Score : cardinal;
end;

var
 HSTable : array [1..10] of THScore;

procedure ResetHSTable;
procedure LoadHSTable;
procedure SaveHSTable;
procedure SetName(Name : string; Score: cardinal);

implementation

procedure SaveHSTable;
var i : integer; F : file;
begin

 AssignFile(F,'Data\Scores.dat');
 Rewrite(F,1);

 for i:=1 to 10 do
 BlockWrite(F,HSTable[i],SizeOf(THScore));

 CloseFile(F);

end;


procedure SetName(Name : string; Score: cardinal);
var i, a : integer;
t, t1 : THScore;
begin
 for i:=1 to 10 do

  if Score>=HSTable[i].Score then
  begin

  t1:=HSTable[i];
  t:=HSTable[i];

  HSTable[i].Name:=Name;
  HSTable[i].Score:=Score;

  if i<>10 then

   for a:=i+1 to 10 do
   begin
   if a<10 then
   t1:=HSTable[a];
   HSTable[a]:=t;
   t:=t1;
   end;

  Exit;
  end;
end;


procedure LoadHSTable;
var i : integer; F : file;
begin
if fileexists('Data\Scores.dat') then
begin
  AssignFile(F,'Data\Scores.dat');
  Reset(F,1);

  for i:=1 to 10 do
  BlockRead(F,HSTable[i],SizeOf(THScore));

  CloseFile(F);
end else ResetHSTable;
end;

procedure ResetHSTable;
var i : integer;
begin
 for i:=1 to 10 do
 begin
  HSTable[i].Name:='Noname';
  HSTable[i].Score:=0;
 end;
end;


end.
