unit Global;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Use_Geom,
  Use_Bass;

const
  MaxBalls = 50;
  MaxBlocks = 200;
  MaxParts = 30000;

type
  TPart = record
   life:byte;
   Point:TVect;
   Vect:TVect;
   tip:byte;
  end;

type
  TBall = record
   real:boolean;
   Point:TVect;
   Vect:TVect;
   Correct:TVect;
   tip:byte;
   Rad:single;
  end;

type
  TBlock = record
   life:byte;
   Point:TVect;
   tip:byte;
   bonus:byte;
  end;

type
  TPlanka = record
    Point:TVect;
    Vect:TVect;
    Width:Single;
    Rad:Single;
    tip:byte;
    magnit:boolean;
  end;

type
  TSave_game_var = array [0..MaxBlocks] of TBlock;

const {block_types}
 bt_usual=0;
 bt_corrupted0=1;
 bt_corrupted1=2;
 bt_corrupted2=3;
 bt_corrupted3=4;
 bt_Armour=5;
 bt_UArmourDU=6;
 bt_DArmourUU=7;
 bt_UArmourDB=8;
 bt_DArmourUB=9;
 bt_Blowing=11;{green}
 bt_Blowing0=12;{Red0}
 bt_Blowing1=13;{Red1}
 bt_Blowing2=14;{Red2}
 bt_Radio=15;
 bt_RadioBlowing=16;{}


var
  hWnd: THandle;      {  }
  Msg: TMsg;
  WCE: TWndClassEx;
  PW,PH:integer;
  glhRC:HGLRC;
  glhDC:HDC;
  Mode:integer = 0;   
  {timer}
  tactH: Integer;
  {keys}
  key: array [0..255] of boolean; {     -   ?}
  {Screen props}
  Mash:single = 1;{}
  KX,KY:single;{  }
  {mouse coords}
  Mx,My:integer;   {}
  CX,CY:single;    {GL  }

  {games}
  Blocks:array [0..MaxBlocks] of TBlock;   { }
  Balls:array [0..MaxBalls] of TBall;
  Parts:array [0..MaxParts] of TPart;
  Hero:TPlanka; { ;) }
  BallSpeed:single;
  BallTip:byte = 0;{type of balls}
  BallTime:integer; {time to bonus balls}
  POINTS:INTEGER; {!}
  LIVES:integer = 5;

  {for edit;}
  Edit_Mode:boolean;
  EX,EY:single;
  EditElement:integer;
  EditBonus:integer;

  {borders}
  XMin,XMax,YMin,YMax:single;

  {triggers}
  Fon_num:byte;
  Alpha_walls:byte;
  Is_Started:boolean = false;

  Anim:integer;

  {Block size}
  BSX:single = 0.8;
  BSY:single = 0.4;


  mbl,mbr,mbm:boolean;       {     }

  {Textures}
  Fon:cardinal;          {  }
  TexBlocks:cardinal; {  }
  TexParts:cardinal; {    }

  {Sounds}
  Music:TSound;
  Booms,Bams,beem,tum,Menu,bonus:TSound;

implementation

end.
