unit Main;

interface

uses     
  Windows,
  Messages,
  OpenGL,
  Global,
  TGA2,
  Use_OpenGL,
  SysUtils,
  Use_Geom,
  Use_Bass,
  Use_Phys,
  Use_Menu;

procedure TactTimer;
procedure Create_prog;
procedure Kill_Prog;

implementation

procedure Check_Keys;       { }
Var
  P:TPoint;
  {zx,zy,}Speed:single;
  mp,i:integer;
begin
 GetCursorPos(P);    { }
 MX:=P.X;
 MY:=P.Y;
 CX:=((+MX-PW/2)*0.0129/mash)+kx;
 CY:=((-MY+PH/2)*0.0129/mash)+ky; {   }
 {Hero Move}   {1024x726  78/838}
 Speed:=0.03;
 Hero.Vect.X:=Hero.Vect.X*0.85;
{ if (Hero.Point.X>(XMax)*(MX-78)/760) then Speed:=-Speed;
 if (abs(Hero.Point.X-(XMax)*MX/PW)>=Hero.Vect.X) then
  Hero.Vect.X:=Hero.Vect.X+Speed else Hero.Vect:=Vector(Hero.Point.X-(XMax)*(MX-78)/760,0);
 }
{}
 if Mode=2 then
 begin
  if key[65] or key[37] then Hero.Vect.X:=Hero.Vect.X-Speed;
  if key[68] or key[39] then Hero.Vect.X:=Hero.Vect.X+Speed;
  if (key[17] or mbl or key[32]) and (Hero.tip>0) and (Hero.tip<99) then  {fire}
   begin
    Hero.tip:=Hero.tip-1;
    add_Ball(Hero.Point.X,Hero.Point.Y,0,0.15,0.1,2);
    mbl:=false;
    key[17]:=false;
    key[32]:=false;
   end;
   if (key[17] or mbl or key[32]) and (Hero.tip=99) then  {begin fire}
   begin
    Hero.tip:=0;
    add_Ball(Hero.Point.X,Hero.Point.Y,Random(20)/200-0.05,0.15,0.1,0);
    mbl:=false;
    key[17]:=false;
    key[32]:=false;
   end;
 end;
 Hero.Point:=plus(Hero.Point,Hero.Vect);
 if (Hero.Point.X<XMin) then begin Hero.Point.X:=XMin;Hero.Vect.X:=0;end;
 if (Hero.Point.X>XMax) then begin Hero.Point.X:=XMax;Hero.Vect.X:=0;end;
 if Mode=3 then
 begin
  if key[87] or key[38] then begin EY:=EY+0.4;key[38]:=false;key[87]:=false;end;
  if key[83] or key[40] then begin EY:=EY-0.4;key[40]:=false;key[83]:=false;end;
  if key[65] or key[37] then begin EX:=EX-0.4;key[37]:=false;key[65]:=false;end;
  if key[68] or key[39] then begin EX:=EX+0.4;key[39]:=false;key[68]:=false;end;
 end;
 if (EX<XMin) then EX:=XMin;
 if (EY<YMin) then EY:=YMin;
 if (EX>XMax-0.8) then EX:=XMax-0.8;
 if (EY>YMax-0.4) then EY:=YMax-0.4;
 if key[112] then begin key[112]:=false;Save_Level('test.txt');end; {f1 save}
 if key[113] then begin key[113]:=false;Load_Level('test.txt');end; {f2 load}
 if key[27] then {Esc }
  begin
   if mode<>1 then mode:=1 else
    if Is_Started then mode:=2;
   key[27]:=false;
  end;
 if key[114] then begin key[114]:=false;Mode:=3;end;
 if key[115] then begin key[114]:=false;Mode:=2;end;
 if key[116] then begin Is_Sound:=not Is_Sound;Pause_Sound(music);Play_Sound(music);key[116]:=false; end;
 {for edit}
 if Mode=3 then
 begin  {block types}
  if key[49] then begin EditElement:=bt_usual;        key[49]:=false;end;
  if key[50] then begin EditElement:=bt_corrupted0;   key[50]:=false;end;
  if key[51] then begin EditElement:=bt_Armour;       key[51]:=false;end;
  if key[52] then begin EditElement:=bt_UArmourDU;    key[52]:=false;end;
  if key[53] then begin EditElement:=bt_DArmourUU;    key[53]:=false;end;
  if key[54] then begin EditElement:=bt_UArmourDB;    key[54]:=false;end;
  if key[55] then begin EditElement:=bt_DArmourUB;    key[55]:=false;end;
  if key[56] then begin EditElement:=bt_Blowing;      key[56]:=false;end;
  if key[57] then begin EditElement:=bt_Blowing0;     key[57]:=false;end;
  if key[48] then begin EditElement:=-1;              key[48]:=false;end;
  if key[189] then begin EditElement:=bt_Radio;       key[189]:=false;end;
  if key[187] then begin EditElement:=bt_RadioBlowing;key[187]:=false;end;
 {bonuses}
  if key[81] then begin EditBonus:=21; key[81]:=false;end;
  if key[79] then begin EditBonus:=22; key[79]:=false;end;
  if key[69] then begin EditBonus:=23; key[69]:=false;end;
  if key[82] then begin EditBonus:=24; key[82]:=false;end;
  if key[84] then begin EditBonus:=25; key[84]:=false;end;
  if key[89] then begin EditBonus:=26; key[89]:=false;end;
  if key[85] then begin EditBonus:=27; key[85]:=false;end;
  if key[73] then begin EditBonus:=28; key[73]:=false;end;
  if key[80] then begin EditBonus:=0;  key[80]:=false;end;
  {add}
  if key[32] then
   begin add_block(EX,EY,EditElement,EditBonus); key[32]:=false;end;
 end;
end;

procedure put_Ball(X,Y,M,R:Single;tip:byte);
Var a,b:byte;
begin
 a:=tip;b:=2;
 glColor4f(5,5,5,4);
 glBegin(GL_QUADS);  {left}
  glTexCoord2f(a*0.25+0.25,b*0.25);        glVertex2f((X-R)*M,(Y+R)*M);
  glTexCoord2f(a*0.25,b*0.25);             glVertex2f((X+R)*M,(Y+R)*M);
  glTexCoord2f(a*0.25,b*0.25+0.25);        glVertex2f((X+R)*M,(Y-R)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25+0.25);   glVertex2f((X-R)*M,(Y-R)*M);
 glEnd;
end;

procedure put_Part(X,Y,M,R:Single;life,tip:byte);
Var a,b:byte;
begin
 case tip of
  0:begin a:=1;b:=0;end;
  1:begin a:=1;b:=0;R:=2*R;end;
  2:begin a:=0;b:=1;{R:=0.4*R;}end;{rain}
  3:begin a:=0;b:=1;R:=0.6*R;end;{small rain}
  5:begin a:=3;b:=0;R:=5*R;end;{small rain}
  11:begin a:=0;b:=0;end;{big snow}
  12:begin a:=0;b:=0;R:=0.5*R;end;{small snow}
  21..24:begin a:=tip-21;b:=2;R:=life*0.4*R;end; {bonuses}
  25..28:begin a:=tip-25;b:=3;R:=life*0.4*R;end; {bonuses}
 end;
 if life>10 then glColor4f(5,5,5,4) else
  glColor4f(5,5,5,life/5);
 glBegin(GL_QUADS);  {left}
  glTexCoord2f(a*0.25+0.25,b*0.25);       glVertex2f((X+R)*M,(Y+R)*M);
  glTexCoord2f(a*0.25,b*0.25);            glVertex2f((X-R)*M,(Y+R)*M);
  glTexCoord2f(a*0.25,b*0.25+0.25);       glVertex2f((X-R)*M,(Y-R)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25+0.25);  glVertex2f((X+R)*M,(Y-R)*M);
 glEnd;
end;

procedure put_Hero(X,Y,M,W:Single);
Var a,b:byte;H:single;
begin
 H:=0.8;
 a:=0;b:=3;
 glColor4f(5,5,5,4);
 glBegin(GL_QUADS);  {left}
  glTexCoord2f(a*0.25+0.25,b*0.25);       glVertex2f((X-W)  *M,(Y+H)*M);
  glTexCoord2f(a*0.25,b*0.25);            glVertex2f((X-W-H)*M,(Y+H)*M);
  glTexCoord2f(a*0.25,b*0.25+0.25);       glVertex2f((X-W-H)*M,(Y)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25+0.25);  glVertex2f((X-W)  *M,(Y)*M);
 glEnd;
 glBegin(GL_QUADS);   {rigth}
  glTexCoord2f(a*0.25,b*0.25);            glVertex2f((X+W+H)*M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25);       glVertex2f((X+W)  *M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25+0.25);  glVertex2f((X+W)  *M,(Y)*M);
  glTexCoord2f(a*0.25,b*0.25+0.25);       glVertex2f((X+W+H)*M,(Y)*M);
 glEnd;
 a:=2;b:=3;
 glBegin(GL_QUADS);   {Center}
  glTexCoord2f(a*0.25,b*0.25);            glVertex2f((X-W)*M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25);       glVertex2f((X+W)*M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25,b*0.25+0.25);  glVertex2f((X+W)*M,(Y)*M);
  glTexCoord2f(a*0.25,b*0.25+0.25);       glVertex2f((X-W)*M,(Y)*M);
 glEnd;
 if (Hero.tip=0) then
  begin a:=1;b:=3;end else  {usual}
  if (Hero.tip=99) then
   begin a:=3;b:=2;end else
   begin a:=3;b:=3;end;  {cannon}
//  a:=3;b:=2; {magnit}
 glBegin(GL_QUADS);   {Main}
  glTexCoord2f(a*0.25+0.01,b*0.25);            glVertex2f((X-0.4)*M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25-0.01,b*0.25);       glVertex2f((X+0.4)*M,(Y+H)*M);
  glTexCoord2f(a*0.25+0.25-0.01,b*0.25+0.25);  glVertex2f((X+0.4)*M,(Y)*M);
  glTexCoord2f(a*0.25+0.01,b*0.25+0.25);       glVertex2f((X-0.4)*M,(Y)*M);
 glEnd;
end;

procedure put_block(X,Y,W,H,M:Single;tip:byte);
Var a,b:byte;
begin
 case tip of
  bt_usual:begin a:=3;b:=0; end;
  bt_corrupted0:begin  a:=0;b:=0;end;
  bt_corrupted1:begin  a:=0;b:=1;end;
  bt_corrupted2:begin  a:=0;b:=2;end;
  bt_corrupted3:begin  a:=0;b:=3;end;
  bt_Armour    :begin  a:=2;b:=0;end;
  bt_UArmourDU :begin  a:=2;b:=2;end;
  bt_DArmourUU :begin  a:=2;b:=1;end;
  bt_UArmourDB :begin  a:=3;b:=2;end;
  bt_DArmourUB :begin  a:=3;b:=1;end;
  bt_Blowing   :begin  a:=1;b:=0;end;
  bt_Blowing0  :begin  a:=1;b:=1;end;
  bt_Blowing1  :begin  a:=1;b:=2;end;
  bt_Blowing2  :begin  a:=1;b:=3;end;
  bt_RadioBlowing:begin  a:=2;b:=3;end;
  bt_Radio     :begin  a:=3;b:=3;end;
 end;
 glColor4f(5,5,5,4);
 glBegin(GL_QUADS);
  glTexCoord2f(a*0.25+0.25,b*0.125);
  glVertex2f((X+W)*M,(Y+H)*M);
  glTexCoord2f(a*0.25,b*0.125);
  glVertex2f((X)  *M,(Y+H)*M);
  glTexCoord2f(a*0.25,b*0.125+0.125);
  glVertex2f((X)  *M,(Y)*M);
  glTexCoord2f(a*0.25+0.25,b*0.125+0.125);
  glVertex2f((X+W)*M,(Y)*M);
 glEnd;
end;

procedure Render;    {}
Var
  i,j:integer;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
{render}
 {borders}
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_Texture_2d,Fon);
 glColor4f(5,5,5,4);
 glBegin(GL_QUADS);
  glTexCoord2f(1,0);
  glVertex2f(7,-5);
  glTexCoord2f(1,1);
  glVertex2f(7,5);
  glTexCoord2f(0,1);
  glVertex2f(-7,5);
  glTexCoord2f(0,0);
  glVertex2f(-7,-5);
 glEnd;
 glDisable(GL_TEXTURE_2D);
 if (Mode=2) or (Mode=3) then
  begin if Alpha_walls<40 then Alpha_walls:=Alpha_walls+1 end else
  if Alpha_walls>0 then Alpha_walls:=Alpha_walls-1;
  glColor4f(5,5,5,Alpha_walls/10);
 glBegin(GL_LINE_LOOP);
  glVertex2f((XMin-KX)*Mash,(YMin-KY)*Mash);
  glVertex2f((XMax-KX)*Mash,(YMin-KY)*Mash);
  glVertex2f((XMax-KX)*Mash,(YMax-KY)*Mash);
  glVertex2f((XMin-KX)*Mash,(YMax-KY)*Mash);
 glEnd;
  {in edit mode}
 if (Mode=3) then
 begin
  glColor4f(3,3,3,4);
  glBegin(GL_LINE_LOOP);
   glVertex2f((EX-KX)*Mash,(EY-KY)*Mash);
   glVertex2f((EX+BSX-KX)*Mash,(EY-KY)*Mash);
   glVertex2f((EX+BSX-KX)*Mash,(EY+BSY-KY)*Mash);
   glVertex2f((EX-KX)*Mash,(EY+BSY-KY)*Mash);
  glEnd;
 end;
 glEnable(GL_TEXTURE_2D);
 glColor4f(2,2,2,4);
 glBindTexture(GL_Texture_2d,TexParts);
 for i:=0 to MaxParts do
  if (Parts[i].life>0) then
   put_Part(Parts[i].Point.X-KX,Parts[i].Point.Y-KY,
    Mash,0.1,Parts[i].life,Parts[i].tip);
 {in edit mode}
 if (Mode=3) and (EditBonus>0) then put_Part(-0.4-KX,10.6-KY,Mash,0.1,10,EditBonus);
 glBindTexture(GL_Texture_2d,TexBlocks);
 for i:=0 to MaxBlocks do
  if Blocks[i].life>1 then
  put_block(Blocks[i].Point.X-KX,Blocks[i].Point.Y-KY,
   BSX,BSY,Mash,Blocks[i].tip) else
  if Blocks[i].life>0 then
  put_block(Blocks[i].Point.X+0.1-KX,Blocks[i].Point.Y+0.05-KY,
   0.6,0.3,Mash,Blocks[i].tip);
 for i:=0 to MaxBalls do
  if Balls[i].real then
  put_Ball(Balls[i].Point.X-KX,Balls[i].Point.Y-KY,
   Mash,Balls[i].Rad*2,Balls[i].tip);
 if Mode=2 then
 for i:=1 to LIVES do
  put_Ball(XMax+1-KX,YMax-2-KY-i*0.6,Mash,0.2,BallTip);
 {test:=test+1;
 if test>200 then test:=0;}
 if Is_Started then
  put_Hero(Hero.Point.X-KX,Hero.Point.Y-KX,Mash,Hero.Width);
  {in edit mode}
 if Mode=3 then put_block(-0.8-KX,11.6-KY,BSX,BSY,Mash,EditElement);
 glDisable(GL_TEXTURE_2D);
 put_Menu;
 glEnable(GL_TEXTURE_2D);
 if Mode<>2 then put_block(CX-KX-0.1,CY-KY-0.1,0.2,0.2,Mash,5);
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 Move_Parts;
 Check_Blocks;
 if Mode=2 then
  begin
   Move_objects;
   Check_objects;
  end;
 Check_Menu((CX-KX)*Mash,(CY-KY)*Mash,MBL or MBR);
 Render;        {}
 if (Mode=-1) then Kill_Prog;
end;

procedure Create_prog;{ }
Var
  i,j:integer;
begin
 ShowCursor(false);  { }
 glClearColor(0.0,0.0,0.0,0);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 Gen_Font(glhDC);  {  ,       :(}
 glDisable(GL_Depth_Test);  {   }
 {game options}
 XMin:=0;
 YMin:=0;
 XMax:=12;
 YMax:=12;
 Mash:=0.82;
 KX:=6.85;
 KY:=6;
 {player}
 Hero.Point.X:=0;
 Hero.Point.Y:=1;
 Hero.Rad:=1.2;
 Hero.Width:=0.2;
 Hero.tip:=0;
 Hero.tip:=99; {begin ball position}
 BallSpeed:=0.06;
 {textures}
 TexParts:=1;
 TexBlocks:=2;
 Fon:=3;
 LoadTGATexture('IMG/Parts.tga',TexParts);
 LoadTGATexture('IMG/Blocks.tga',TexBlocks);
 Randomize;
 Fon_num:=Random(3);
 Case Fon_Num of
  0:LoadJPGTexture('IMG/MoonShine.jpg',Fon);
  1:LoadJPGTexture('IMG/WizeRocks.jpg',Fon);
  2:LoadJPGTexture('IMG/RainHills.jpg',Fon);
 end;
 {edit}
 EX:=0;
 EY:=0;
 Create_Menu;
 {Sounds}
 Init_Sounds(hWnd);
 Load_Sound(Menu,'SOUNDS\Menu.wav');
 Load_Sound(Bonus,'SOUNDS\Bonus.wav');
 Load_Sound(Booms,'SOUNDS\Booms.wav');
 Load_Sound(Tum,'SOUNDS\tum.wav');
 Load_Sound(beem,'SOUNDS\Beem.wav');
 Load_Sound(Bams,'SOUNDS\Bams.wav');
 Load_Sound(music,'SOUNDS\Music.mp3');
 Play_Sound(music);  {  }
// Load_Sound(beem,'SOUNDS\Beem.wav');
// Load_Level('123.txt');
 {test}
{ For i:=0 to 25 do
   Add_Ball(5,1+i/8,0.03,0,0.05,0);    
 For i:=0 to 35 do
   Add_Ball(1.1+i/20,2,0.0,-0.005,0.2,1);}
{ For i:=0 to 10 do
   Add_Ball(1+i/2,2,0,-0.01,0.2,0);
 For i:=0 to 6 do        
  Add_Ball(Random(12),Random(12),Random(12)/48-0.125,Random(12)/48-0.125,0.1,Random(2));
}
end;

procedure Kill_Prog;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
 KillTimer(0,TactH);     { }
 Kill_Sounds();
 PostQuitMessage (0);
 ShowCursor(True);        { }
end;

end.
