#ifndef FIREBRICK_H_INCLUDED
#define FIREBRICK_H_INCLUDED

#include "string"
#include "Brick.h"

const std::string BRICK_TEXTURE_NAME_3 = "brick3.png";
const std::string BRICK_DIE_SND_NAME = "bdyj.wav";

const float DET_TIME = 0.07;
class FireBrick: public Brick {
      HEFFECT dieSnd;
    public:
        FireBrick(Field *field, hgeVector center, float x, float y, int i, int j, float angle, const char* textureName = BRICK_TEXTURE_NAME_3.c_str());
        void die();

    protected:
        void onHit();

};

#endif // FIREBRICK_H_INCLUDED
