#include "Polygon.h"

Polygon::Polygon (float x, float y, float angle, int n, float *vertices): n(n), angle(angle) {
    coords.x = x;
    coords.y = y;

    vectors.resize(n);

    for (int i = 0; i<n; i++) {
        vectors[i] = new hgeVector(vertices[2*i], vertices[2*i+1]);
    }
};

Polygon::~Polygon() {
    for (int i = 0; i<n; i++) {
        delete vectors[i];
    }
};
