#ifndef WALLBRICK_H_INCLUDED
#define WALLBRICK_H_INCLUDED

#include "Brick.h"

const std::string BRICK_TEXTURE_NAME_2 = "brick2.png";
const std::string BRICK_BALL_HIT_SND_NAME_2 = "tiuk.wav";

class WallBrick:public Brick {
    public:
        WallBrick(Field *field, hgeVector center, float x, float y, int i, int j, float angle, const char* textureName = BRICK_TEXTURE_NAME_2.c_str());
        void die();
        bool isCountable ();
    protected:
        void onHit();

};

#endif // WALLBRICK_H_INCLUDED
